# coding: utf-8
import random as r
import time as t


def fausse_connexion():
    print("On fait mine de se connecter au serveur...")
    for i in range(100):
        i += 1
        t.sleep(0.009)
        print("Updating :", i, "%", end='\r')
    print()
    print("Done !")
    return None


class Cours:
    titre = ""
    enseignant = ""
    salle = 0
    batiment = ''

    def __init__(self, t="Python", e="Axel", s=101, b='C'):
        print("L'objet 'Cours' va être instancié avec les valeurs suivante:",
              "\n\ttitre=", t, "\n\tenseignant=", e, "\n\tsalle=", s, "\n\tbatiment=", b)
        self._titre = t
        self._enseignant = e
        self._salle = s
        self._batiment = b
        print("\nL'objet 'Cours' viens d'être instancié\n")
        return None

    def usage(self, func_name="global", boo=False):
        if not isinstance(func_name, str):
            raise Exception(
                "La fonction usage a mal été utilisé.",
                "\n Faites : (nom_de_l'instace).usage(\"nom_de_la_fonction\") ou (nom_de_l'instace).usage()\n")
        if func_name == "global":
            print("\nL'objet 'Cours' contient les attributs de base suivants :",
                  "\n\ttitre de type str", "\n\tenseignant de type str", "\n\tsalle de type int", "\n\tbatiment de type char\n",
                  "\nLes fonctions pour les modifiés sont respectivement : 'set_titre','set_enseignant','set_salle' et 'set_batiment'.",
                  "\nDe plus vous trouverez une fonction 'detail_du_cours' qui afficheras les détails de votre objet 'Cours'.",
                  "\n Enfin une fonction 'update' qui mettra à jour toutes les informations de votre cours sauf le titre.",
                  "\nPour plus de détails, essayez (nom_de_l'instace).usage(\"nom_de_la_fonction\").\n")
        elif func_name == "set_titre":
            print("\nLa fonction set_titre attend un argument qui est une chaine de caractère (str).",
                  "\nUsage : (nom_de_l'instace).set_titre(\"titre\")\n")
        elif func_name == "set_enseignant":
            print("\nLa fonction set_enseignant attend un argument qui est une chaine de caractère (str).",
                  "\nUsage : (nom_de_l'instace).set_enseignant(\"nom\")\n")
        elif func_name == "set_salle":
            print("\nLa fonction set_salle attend un argument qui est un entier (int).",
                  "\nUsage : (nom_de_l'instace).set_salle(votre_entier)\n")
        elif func_name == "set_batiment":
            print("\nLa fonction set_batiment attend un argument qui est un caractère (char).",
                  "\nUsage : (nom_de_l'instace).set_batiment('votre_caractère')\n")
        elif func_name == "detail_du_cours":
            print("\nLa fonction detail_du_cours n'attend pas d'arguments.",
                  "\nUsage : (nom_de_l'instace).detail_du_cours()\n")
        elif func_name == "update":
            print("\nLa fonction update n'attend pas d'arguments.",
                  "\nUsage : (nom_de_l'instace).update()\n")
        else:
            print(
                "\nFonction inconnue, vérifiez l'orthographe ou faite un (nom_de_l'instace).usage()\n")
        if boo:
            raise Exception(
                "La fonction "+func_name+" a mal été utilisée, référez vous à l'usage ci-dessus.\n")
        return None

    # Ici on traite le setter, getter et destructeur de l'attribut titre
    def set_titre(self, nom=None):
        if (not nom) or (not isinstance(nom, str)):
            return self.usage("set_titre", True)
        print("On change le nom du cours :" +
              self._titre + "->" + nom)
        self._titre = nom
        return None

    def get_titre(self):
        return self._titre

    def del_titre(self):
        del self._titre
        return None

    titre = property(get_titre, set_titre, del_titre)

    # Ici on traite le setter, getter et destructeur de l'attribut enseignant
    def set_enseignant(self, nom=None):
        if (not nom) or (not isinstance(nom, str)):
            return self.usage("set_enseignant", True)
        print("On change le nom de l'enseignant :" +
              self._enseignant + "->" + nom)
        self._enseignant = nom
        return None

    def get_enseignant(self):
        return self._enseignant

    def del_enseignant(self):
        del self._enseignant
        return None

    enseignant = property(get_enseignant, set_enseignant, del_enseignant)

    # Ici on traite le setter, getter et destructeur de l'attribut salle
    def set_salle(self, numero=None):
        if (not numero) or (not isinstance(numero, int)):
            return self.usage("set_salle", True)
        print("On change le numéro de la salle :" +
              str(self._salle)+"->"+str(numero))
        self._salle = numero
        return None

    def get_salle(self):
        return self._salle

    def del_salle(self):
        del self._salle
        return None

    salle = property(get_salle, set_salle, del_salle)

    # Ici on traite le setter, getter et destructeur de l'attribut batiment
    def set_batiment(self, lettre=None):
        if (not lettre) or (not isinstance(lettre, str)) or (len(lettre) > 1):
            return self.usage("set_batiment", True)
        print("On change le batiment :"+self._batiment+"->"+lettre)
        self._batiment = lettre
        return None

    def get_batiment(self):
        return self._batiment

    def del_batiment(self):
        del self._batiment
        return None

    batiment = property(get_batiment, set_batiment, del_batiment)

    # Ici on met les fonctions supplémentaires ou méthodes
    def detail_du_cours(self):
        try:
            print("\nLe cours de", self.titre, "est en",
                  self._batiment + str(self._salle), "avec", self._enseignant)
        except:
            raise Exception(
                "Il y a eu un problème dans la fonction detail_du_cours.\n")
        return None

    def update(self):
        fausse_connexion()
        print("\nLes informations relatives au cours sont mis à jours !")
        ens = {1: "Clément", 2: "Axel", 3: "Maeva",
               4: "Kévin", 5: "Paul-Marie", 6: "Denis", 7: "Papa"}
        sal = [i for i in range(
            26)] + [i for i in range(101, 126)] + [i for i in range(201, 226)]
        bat = {1: 'A', 2: 'B', 3: 'C'}
        r1 = r.randint(1, len(ens))
        r2 = r.randint(0, len(sal))
        r3 = r.randint(1, len(bat)-1)
        self._enseignant = ens[r1]
        self.set_salle(sal[r2])
        self.set_batiment(bat[r3])
        print("\n")
        return None
